
/*------------------------------------------------------------------------------------------------------
	Easter 2013 Intro - Tebe / Madteam
	30.03.2013 .. 08.04.2013
------------------------------------------------------------------------------------------------------*/


	icl "twister_pmg.h"

ver	= 2
	
lheight	= 2		; line height
lines	= 7		; lines
y_ofset	= 0

miss	= $180
ply0	= $200
ply1	= $280
ply2	= $300
ply3	= $380

pmg	= $0400
pmgClr	= $0000

RASTERMUSICTRACKER = $DC00 ; .. $ecc5
MODUL	= $E100

scrTmp	= $f000
	
	org $80
	
rmt_zp	.ds 19
	
fcnt	.ds 2
fadr	.ds 2		; korzysta NMI !!!
fhlp	.ds 2

cloc	.ds 1

regA	.ds 1
regX	.ds 1
regY	.ds 1

mul	.ds 2

ahpos	.ds 1

semafor	.ds 1


	org $600
iText	mva #$ff portb
	mva #$40 nmien

	jsr printf
	dta c'Easter Twist ''2013',$9b
	dta c'------------------',$9b
	dta c'Agenda & Madteam',$9b,0

	rts
	
	.link 'printf.obx'
	
	.print *
	ini iText


	org $a000

.local	logo

fnt	ins 'baranekEaster_load.fnt'

ant	dta $70
	dta $70,$70,$70,$70,$70,$70,$70,$44|$10,a(scr),$04|$10,$04|$10,$04|$10,$04|$10,$04|$10,$04|$10,$04|$10,$04|$10
	dta $04|$10,$04|$10,$04|$10,$70,$04|$10
ant_e	dta $04|$10
	dta $41,a(ant)

scr	ins 'baranekEaster_load.scr'

init	jsr kdos.main

	lda:cmp:req 20
	
	lda #0
	:5 sta 708+#

	mwa #ant 560
	mva #scr32 559
	mva >fnt 756
	
	ldy #15
mloop	ldx #1
@	lda:cmp:req 20
	dex
	bpl @-

	ldx #4
loop	lda 708,x

	and #$0f
	cmp lcol,x
	seq
	inc 708,x
	
	lda 708,x
	and #$f0
	cmp hcol,x
	seq
	adb 708,x #$10

skp	dex
	bpl loop

	dey
	bpl mloop

	rts


.local	fadeOut

	jsr box.main

	mwa #0 cnt

loop	cpw cnt #96
	scc
	jsr box.loop
	
	cpw cnt #200
	bcs stop

@	lda vcount
	cmp #36
	bne @-
	
	ldx #127
@	lda 20
	add vcount
	tay
	lda tsin,y
	lsr @
	lsr @
	tay
	lda ssin,y

	and #$07
	sta wsync
	nop
	sta hscrol
	
	dex
	bpl @-

	inw cnt
	jmp loop

stop	mva #$70 ant_e			; baranek zasloniety, podmiana DLISTY i nie bedzie baranka
	mwa #ant_e 560
	
	lda:cmp:req 20
	rts

ssin	:16 dta 0,1,2,3,4,5,6,7,7,6,5,4,3,2,1,0

cnt	.word
.endl

	
lcol	.he 0e 00 08 08 04
hcol	.he 00 00 20 10 00

.local	kdos
	icl 'kdos.asm'
.endl

.local	box
	icl 'box_1.asm'
.endl

	.print 'logo: ',*
.endl

	ini logo.init


	opt h-
	ins 'music.exo'
	opt h+


; ---	MAIN PROGRAM
	org $2000

fnt	ift ver=0
		ins 'kurak_dlip.fnt'
	eli ver=1
		ins 'kurak_dlip32.fnt'
	eli ver=2
		ins 'kurak.fnt'
	eli ver=3
		ins 'kurak_limit.fnt'
	eif

afnt	ins 'atari.fnt'

	ert <*<>0
tsin	ins 'sin.bin'


	ift ver=3
mod48	:512 dta #%48
mod32	:512 dta #%32

drawTnl
	.wo tunel.draw_col0
	.wo tunel.draw_col1
	.wo tunel.draw_col2
	.wo tunel.draw_col3
	.wo tunel.draw_col4
	.wo tunel.draw_col5
	.wo tunel.draw_col6
	.wo tunel.draw_col7
	.wo tunel.draw_col8
	.wo tunel.draw_col9
	.wo tunel.draw_col10
	.wo tunel.draw_col11
	.wo tunel.draw_col12
	.wo tunel.draw_col13
	.wo tunel.draw_col14
	.wo tunel.draw_col15
	.wo tunel.draw_col16
	.wo tunel.draw_col17
	.wo tunel.draw_col18
	.wo tunel.draw_col19
	.wo tunel.draw_col20
	.wo tunel.draw_col21
	.wo tunel.draw_col22
	.wo tunel.draw_col23
	.wo tunel.draw_col24
	.wo tunel.draw_col25
	.wo tunel.draw_col26
	.wo tunel.draw_col27
	.wo tunel.draw_col28
	.wo tunel.draw_col29
	.wo tunel.draw_col30
	.wo tunel.draw_col31
	.wo tunel.draw_col32
	eif

	icl 'frm\char_6.asm'
	icl 'frm\char_12.asm'
	icl 'frm\char_14.asm'
	icl 'frm\char_24.asm'
	icl 'frm\char_28.asm'
	icl 'frm\char_48.asm'
	icl 'frm\char_54.asm'
	icl 'frm\char_56.asm'
	icl 'frm\char_59.asm'
	icl 'frm\char_60.asm'
	icl 'frm\char_62.asm'
	icl 'frm\char_64.asm'
	icl 'frm\char_70.asm'
	icl 'frm\char_96.asm'
	icl 'frm\char_99.asm'
	icl 'frm\char_102.asm'
	icl 'frm\char_107.asm'
	icl 'frm\char_108.asm'
	icl 'frm\char_110.asm'
	icl 'frm\char_111.asm'
	icl 'frm\char_112.asm'
	icl 'frm\char_118.asm'
	icl 'frm\char_119.asm'
	icl 'frm\char_120.asm'
	icl 'frm\char_124.asm'
	icl 'frm\char_126.asm'
	icl 'frm\char_127.asm'
	icl 'frm\char_255.asm'

scr	ift ver=0
		ins 'kurak_dlip.scr'
	eli ver=1
		ins 'kurak_dlip32.scr'
	eli ver=2
		ins 'kurak.scr'
	eli ver=3
		ins 'kurak_limit.scr'
	eif


.macro	@char
	.def _:1
	lda	:1.missiles,y
	:lheight sta pmg+miss+y_ofset+#,x

	lda	:1.player0,y
	:lheight sta pmg+ply0+y_ofset+#,x

	lda	:1.player1,y
	:lheight sta pmg+ply1+y_ofset+#,x

	lda	:1.player2,y
	:lheight sta pmg+ply2+y_ofset+#,x

	lda	:1.player3,y
	:lheight sta pmg+ply3+y_ofset+#,x

	jmp	line.return
.endm

	@char	char_6
	@char	char_12
	@char	char_14
	@char	char_24
	@char	char_28
	@char	char_48
	@char	char_54
	@char	char_56
	@char	char_59
	@char	char_60
	@char	char_62
	@char	char_64
	@char	char_70
	@char	char_96
	@char	char_99
	@char	char_102
	@char	char_107
	@char	char_108
	@char	char_110
	@char	char_111
	@char	char_112
	@char	char_118
	@char	char_119
	@char	char_120
	@char	char_124
	@char	char_126
	@char	char_127
	@char	char_255

	.align

chars	.wo	0
	.wo	_char_6
	.wo	_char_12
	.wo	_char_14
	.wo	_char_24
	.wo	_char_28
	.wo	_char_48
	.wo	_char_54
	.wo	_char_56
	.wo	_char_59
	.wo	_char_60
	.wo	_char_62
	.wo	_char_64
	.wo	_char_70
	.wo	_char_96
	.wo	_char_99
	.wo	_char_102
	.wo	_char_107
	.wo	_char_108
	.wo	_char_110
	.wo	_char_111
	.wo	_char_112
	.wo	_char_118
	.wo	_char_119
	.wo	_char_120
	.wo	_char_124
	.wo	_char_126
	.wo	_char_127
	.wo	_char_255

	ift ver=0
		icl 'dl_40.asm'
	eli ver=1
		icl 'dl_32.asm'
	eli ver=2
		icl 'dl.asm'
	eli ver=3
		icl 'dl_limit.asm'
	eif

main
	jsr logo.fadeOut
	
; ---	init PMG

	mva >pmg pmbase		;missiles and players data address
	mva #$03 pmcntl		;enable players and missiles

	lda:cmp:req 20		;wait 1 frame

	sei			;stop IRQ interrupts
	mva #$00 nmien		;stop NMI interrupts
	sta $d400
	sta dmactl
	mva #$fe portb		;switch off ROM to get 16k more ram

	mwa #NMI $fffa		;new NMI handler

	jsr CopyScreen

	ldx <MODUL				;low byte of RMT module to X reg
	ldy >MODUL				;hi byte of RMT module to Y reg
	lda #0					;starting song line 0-255 to A reg
	jsr RASTERMUSICTRACKER		;Init
	
; clear pmg	
	ldx #0
	txa
@	:5 sta pmg+miss+#*$80,x
	:5 sta pmgClr+miss+#*$80,x
	inx
	bpl @-

	ift ver=3
	jsr pal_init
	eif

	mva #$c0 nmien		;switch on NMI+DLI again

/*------------------------------------------------------------------------------------------------------
	TWISTER SCROLL
------------------------------------------------------------------------------------------------------*/
	lda #0
	sta fhlp
	sta fhlp+1
	sta fcnt
	sta fcnt+1
	sta fadr
	sta fadr+1

	sta semafor

	mva #64-5+44 ahpos

loop	lda semafor			; ! ta metoda pewniejsza niz 'lda:cmp:req cloc'
	beq loop

	mva #0 semafor

lpScr	lda #lines*lheight
start	equ *-1
	sta fcnt	

	lda #0
_fhlp	equ *-1
	sta fhlp
	
	lda #0
_vsin	equ *-1
	sta line._sin
	
lp	ldy #0
chr	equ *-1

	ldx scroll,y
ascr	equ *-2
	bmi fx

skip	jsr char

	inc chr
	ldy chr
	cpy #9 ;11		; liczba znakow scrolla
	bne lp
	
	mva #0 chr

	lda cloc		; slow
	and #1
	bne skp
	
	dec start
	bne skp

	adb _vsin #lines
	
	lda _fhlp
	add #0
twirl	equ *-1
	sta _fhlp

	mva #lines*lheight start

	inw ascr
	
skp	bit _fhlp

	inc _vsin

	jsr RASTERMUSICTRACKER+3	;1 play

rastBar	jsr raster_bars
	
stopFill jsr FillScreen

;	mva #$f $d01a
	
	jmp loop


.local	fx

	cpx #$80	; !
	beq fx0
	cpx #$81	; !
	beq fx1
	cpx #$82	; !
	beq fx2
	cpx #$83	; !
	beq fx3
	cpx #$84	; !
	beq fx4
	cpx #$85	; !
	beq fx5

;	cpx #$87	; !
;	beq fx_new

fx_new	mva #0 line.rot0
	sta fadr+1
	sta twirl
	mva #{bit*} nmi.swing
;	sta skp
	sta line._sin-1
	mva #{sta 0} char.twirl

	mwa #scroll ascr

	jmp _skip

fx5	mva #{bit*} line._sin-1
	jmp _skip

fx4	mva #{bit 0} char.twirl
	mva #lines*2	twirl
	jmp _skip

fx3	mva #2 line.rot0
	jmp _skip

fx2	mva #{inc*} nmi.swing
	jmp _skip

fx1	mva #1 fadr+1
	jmp _skip

fx0	mva #{adc*} line._sin-1
	mva #{inc*} skp

_skip	ldx #" "
	jmp skip
.endl


/*------------------------------------------------------------------------------------------------------
	CHAR (in: X-REG)
------------------------------------------------------------------------------------------------------*/
.local	char

	mva #0 mul+1

	txa
	asl @
	rol mul+1
	asl @
	rol mul+1
	asl @
	rol mul+1
	sta mul
	
	add <afnt
	sta mul
	lda mul+1
	adc >afnt
	sta mul+1
	
	mva fhlp tmp2

;	mva line._sin tmp

	ldy #1
	jsr line

	ldy #2
	jsr line

	ldy #3
	jsr line

	ldy #4
	jsr line

	ldy #5
	jsr line

	ldy #6
	jsr line

	ldy #7
	jsr line

;	lda #0
;tmp	equ *-1
;	sta line._sin
	
	lda #0
tmp2	equ *-1
twirl	sta fhlp

	rts
.endl


.local	zero

	ldx fcnt			; y position
	
	lda #0

	:lheight sta pmg+miss+y_ofset+#,x
	:lheight sta pmg+ply0+y_ofset+#,x
	:lheight sta pmg+ply1+y_ofset+#,x
	:lheight sta pmg+ply2+y_ofset+#,x
	:lheight sta pmg+ply3+y_ofset+#,x

	jmp line.return
.endl

/*------------------------------------------------------------------------------------------------------
	LINE (in: Y-REG)
------------------------------------------------------------------------------------------------------*/
.local	line

	lda (mul),y
	beq zero

	asl @
	sta _jmp+1
	
	ldx fcnt			; y position

	lda fhlp
	clc
	bit tsin
_sin	equ *-2

	and #$7f
	tay

_jmp	jmp (chars)
	
return	adb fcnt #lheight

	inc _sin

	lda fhlp
	add #0
rot0	equ *-1
	sta fhlp

	rts
.endl

; ---	DLI PROGRAM

	?old_dli = *

dli_start

	ift ver=0
		icl 'dli_40.asm'
	eli ver=1
		icl 'dli_32.asm'
	eli ver=2
		icl 'dli.asm'
	eli ver=3
		icl 'dli_limit.asm'
	eif

/*------------------------------------------------------------------------------------------------------
	NMI
------------------------------------------------------------------------------------------------------*/
.proc	NMI

	bit nmist
	bpl VBL

	jmp dli_start
dliv	equ *-2

VBL
	sta regA
	stx regX
	sty regY

	sta nmist		;reset NMI flag

	mwa #ant dlptr		;ANTIC address program

	sta semafor

	ift ver=0 || ver=2 || ver=3
		mva #@dmactl(standard|dma|players|missiles|lineX2) dmactl	;set new screen width
	eli ver=1
		mva #@dmactl(narrow|dma|players|missiles|lineX2) dmactl	;set new screen width
	eif

; Initial values

	lda >fnt+$400*$00
	sta chbase

	mva >pmgClr pmbase
	
;	lda #$04
;	sta vscrol

	lda #$00
	sta colbak
	sta color1
	
	lda #$00
	sta sizep0
	sta sizep1
	sta sizep2
	sta sizep3

	sta sizem

c1	lda #$0E
	sta color0
c3	lda #$28
	sta color2
c4	lda #$24
	sta color3
	
	lda #$21
	sta gtictl

	lda #0
_f	equ *-1
	sta fadr
swing	bit _f

	mwa #dli_start dliv	;set the first address of DLI interrupt

;this area is for yours routines

	jsr RASTERMUSICTRACKER+3	;1 play

	inc cloc		;little timer

quit
	lda regA
	ldx regX
	ldy regY
	rti

.endp


/*------------------------------------------------------------------------------------------------------
	SCROLL
------------------------------------------------------------------------------------------------------*/

scroll	dta d'            Hello and',$82,d'welcome',$80,d'dear friends !       ',$83
	dta d'Wishing You a very Happy Easter With love and Best Wishes...       ',$84,$81,$85
	dta d'May that Easter Day brings Lot of Happiness in Yourlife !       ',$80
	dta d'This season greetro is created by Agenda and Madteam.',$85
	dta d'Smooth twister scroller coded by',$80,d'Tebe,'
	dta d' pretty little music composed by stRing and one year old chicken picture draw Ooz. ',$85
	dta d' All our kisses we send to '
	dta d'Atari BDSM * NOICE * OXYRON * SQUOQUO * TAQUART * LARESISTANCE * COSINE * TRISTESSE * NG * FANDAL * LAMERS * BLOWJOBB * MEC *'
	dta d' MAPA AND PG * SLIGHT * JAC! * XXL * MATOSIMI * CPU * SSG * MYSTIC BYTES * BLACK SUN * ALONE CODER  and ofcourse to You.'
	dta d'           '
	dta d'Happy Easter !              ',$86

scroll_end

	ift ver=3
	icl 'tunnel.asm'
	eif

/*------------------------------------------------------------------------------------------------------
	COPY SCREEN
------------------------------------------------------------------------------------------------------*/
.local	CopyScreen

	mwa #scr fcnt
	mwa #scrTmp fhlp

	#while .word fcnt < #scr+40*30

	ldy #0
	lda (fcnt),y
	sta (fhlp),y

	tya
	sta (fcnt),y

	inw fcnt
	inw fhlp
	
	#end

	rts
.endl

/*------------------------------------------------------------------------------------------------------
	FILL SCREEN
------------------------------------------------------------------------------------------------------*/
.local	FillScreen

	mva #29 cnt+1

cnt	ldx #29
	lda cols,x
	bne _dec

	mva lscr1,x src
	mva hscr1,x src+1
	
	mva lscr0,x dst
	mva hscr0,x dst+1

	lda rows,x
	cmp #40
	beq skip

	tay
	lda $ffff,y
src	equ *-2
	sta $ffff,y
dst	equ *-2

	inc rows,x
	jmp skip
	
_dec	dec cols,x

skip	dec cnt+1
	bpl cnt

	lda rows
	cmp #40
	sne
	mva #{bit*} stopFill

	inc ahpos
	rts	

cols	:30 dta 255-#*3
rows	:30 brk

lscr0	:30 dta l(scr+#*40)
hscr0	:30 dta h(scr+#*40)

lscr1	:30 dta l(scrTmp+#*40)
hscr1	:30 dta h(scrTmp+#*40)

.endl

/*------------------------------------------------------------------------------------------------------
	LITTLE RASTER BARS
------------------------------------------------------------------------------------------------------*/
.local	raster_bars

	inc cnt
	lda cnt
	cmp #6
	beq b0
	cmp #12
	beq b1
	cmp #18
	beq b2
	cmp #24
	beq b3
	cmp #30
	beq b4

	rts

b0	mva #2 c6+1
	rts
	
b1	mva #0 c7+1
	rts

b2	mva #2 c8+1
	rts

b3	mva #2 c10+1
	rts

b4	mva #2 c12+1

	mva #{bit*} rastBar
	rts

cnt	brk
.endl

	.print 'end: ',*

; ---
	run main
; ---

.MACRO	DLINEW

	lda vcount
	asl @
	and #$f0
	ora #8
	sta colpm0
	sta colpm2
	eor #$5e
	sta colpm1
	sta colpm3

	lda #180

	add tsin
_s	equ *-2

	lsr @
	lsr @
	
	adc ahpos

	?siz = 8

	sta hposp1
	sta hposp0

	adc #?siz
	sta hposp3
	sta hposp2

	adc #?siz
	sta hposm1
	sta hposm0

	adc #?siz/4
	sta hposm3
	sta hposm2

	lda fadr
	adc fadr+1
	sta fadr
	sta _s

	ift :1<>0
		mva <:1 NMI.dliv
		ift [>?old_dli]<>[>:1]
		mva >:1 NMI.dliv+1
		eif
	eif

	ift :2
	lda regA
	eif

	ift :3
	ldx regX
	eif

	ift :4
	ldy regY
	eif

	rti

	.def ?old_dli = *
.ENDM
